PROGRAM ioslave
USE mod_pack, ONLY : set_pack_buffer,pack,unpack
USE mod_wait
IMPLICIT NONE

  INTEGER,DIMENSION(3) :: a=(/1,2,3/)
  REAL                 :: b = 4.5
  REAL                 :: c = 6.7
  INTEGER,DIMENSION(3) :: aout
  REAL                 :: bout,cout
  LOGICAL,DIMENSION(5) :: d=(/.TRUE.,.FALSE.,.FALSE.,.TRUE.,.TRUE./)
  LOGICAL,DIMENSION(5) :: dout
  CHARACTER            :: e='C'
  CHARACTER            :: eout
  CHARACTER(len=11)    :: f(3)
  CHARACTER(len=11)    :: fout(3)
  INTEGER(kind=8),dimension(:),POINTER :: buffer
  REAL,dimension(:),POINTER :: buffer_field
  DOUBLE PRECISION :: t
  
  ALLOCATE(buffer(1024))
  ALLOCATE(buffer_field(1024))
  
  CALL set_pack_buffer(buffer,1)
  
  f(1)="COUCOU1"
  f(2)="COUCOU2"
  f(3)="COUCOU3"
  
  CALL pack(b)
  CALL pack(f)
  CALL pack(a)
  CALL pack(d)
  CALL pack(e)
  CALL pack(c)
  
  CALL set_pack_buffer(buffer,1)
  CALL unpack(bout)
  CALL unpack(fout)
  CALL unpack(aout)
  CALL unpack(dout)
  CALL unpack(eout)
  CALL unpack(cout)
  
  PRINT *,a,b,c,d,e,"  ",f
  PRINT *,aout,bout,cout,dout,eout,"  ",fout

  CALL Init_wait
  
  t=top()
  CALL wait_us(10)
  t=top()
  
  PRINT *,"ATTENTE 10 us",t

  t=top()
  CALL wait_us(250)
  t=top()
  
  PRINT *,"ATTENTE 250 us",t

  t=top()
  CALL wait_us(1235)
  t=top()
  
  PRINT *,"ATTENTE 1235 us",t


END PROGRAM ioslave

